--new color coding

-- labels
-- Glamour_VARIABLE = "foo";

-- globals
Glamour_NAME =  "Glamour";
Glamour_VERSION = "1.0.1";
print(Glamour_NAME.." "..Glamour_VERSION);
--Glamour = { frame = nil};

-- [[ GlamourAlertFrame ]] --
function GlamourAlertFrame_OnLoad (self)
	return;
--	self:RegisterForClicks("LeftButtonUp");
end

function GlamourAlertSample()
	 local MyData = {};
	 MyData.Text = "General Text";
	 MyData.Title = "Title";
	 MyData.Icon = "Interface\\Icons\\INV_Misc_QuestionMark";
	 MyData.tText = "tText";
	 MyData.bText = "bText";
	 MyData.Points = 0;
	 local green = { };
	 green.r = 0;
	 green.g = 1;
	 green.b = 0;
	 local red = { };
	 red.r = 1;
	 red.g = 0;
	 red.b = 0;
		 
	
	 GlamourShowAlert(1, MyData, nil, nil);
	 GlamourShowAlert(1, MyData, red, green);
	--
	 GlamourShowAlert(0, MyData, nil, nil);
	 GlamourShowAlert(0, MyData, red, green); 
	--
	 GlamourShowAlert(400, MyData, green, red); 
	 GlamourShowAlert(200, MyData, red, green); 
end

function GlamourShowAlert(size, data, glow, shine)
	-- size: numeric
	--  	width of the alert frame with the following predefinded values
	--  	0 : Shows just the Icon and IconFrame along with ttext and bttext from the data fields. This mode also hides glow and shine events.
	--  	1 : Default size (width 300);
	--  	* : any other number will be used as a specific size to resize the width too. 300 is the default size, use this as a starting point.
	-- data: keytable: {text, title, icon, ttext, btext, points}
	-- 	Text = Text to display
	-- 	Title = Title to display
	-- 	Icon = icon path to display
	-- 	tText = text to display at the top of the icon
	-- 	bText = text to display at the bottom of the icon
	-- 	Points = numeric value to display ontop of the shield icon (0 for nothing)
	-- glow: keytable: {r,g,b} or nil for default
	-- 	the rgb values to use for the glow animation
	-- shine: keytable: {r,g,b} or nil for default
	-- 	the rgb values to use for the shine animation

	local frame = GlamourAlertFrame_GetAlertFrame();
	if ( not frame ) then
		-- We ran out of frames! Bail!
		return;
	end
	
	--local _, name, points, completed, month, day, year, description, flags, icon, rewardText, isGuildAch = GetAchievementInfo(achievementID);

	local frameName = frame:GetName();
	local displayName = _G[frameName.."Name"];
	local displayNameTop = _G[frameName.."IconNameTop"];
	local displayNameBottom = _G[frameName.."IconNameBottom"];
	local shieldPoints = _G[frameName.."ShieldPoints"];
	local shieldIcon = _G[frameName.."ShieldIcon"];
	local BackGround = _G[frameName.."Background"];
	local Unlocked = _G[frameName.."Unlocked"];
	
	displayName:SetText(data.Text);
	displayNameTop:SetText(data.tText);
	displayNameBottom:SetText(data.bText);

	if (size == 0) then
		frame:SetWidth(44);
		frame.glow:Hide();
		frame.shine:Hide();
		BackGround:Hide();
		Unlocked:Hide();
		displayName:Hide();
		shieldPoints:Hide();
		shieldIcon:Hide();
	elseif (size == 1) then
		frame:SetWidth(300);
		frame.glow:Show();
		frame.shine:Show();
		BackGround:Show();
		Unlocked:Show();
		displayName:Show();
		shieldPoints:Show();
		shieldIcon:Show();
	else
		frame:SetWidth(size);
		frame.glow:Show();
		frame.shine:Show();
		BackGround:Show();
		Unlocked:Show();
		displayName:Show();
		shieldPoints:Show();
		shieldIcon:Show();
	end

	GlamourAchievementShield_SetPoints(data.Points, shieldPoints, GameFontNormal, GameFontNormalSmall);
	
	if (glow) then
		frame.glow:SetVertexColor(glow.r,glow.g,glow.b);
	else
		frame.glow:SetVertexColor(1,1,1);
	end

	if (shine) then
		frame.shine:SetVertexColor(shine.r,shine.g,shine.b);
	else
		frame.shine:SetVertexColor(1,1,1);
	end

	frame.unlocked:SetText(data.Title);
	
	if ( points == 0 ) then
		shieldIcon:SetTexture([[Interface\AchievementFrame\UI-Achievement-Shields-NoPoints]]);
	else
		shieldIcon:SetTexture([[Interface\AchievementFrame\UI-Achievement-Shields]]);
	end
	
	_G[frameName.."IconTexture"]:SetTexture(data.Icon);
	
	frame.id = achievementID;
	
	AlertFrame_AnimateIn(frame);
	
end

function GlamourAlertFrame_GetAlertFrame()
	local name, frame, previousFrame;
	for i=1, 8 do
		name = "GlamourAlertFrame"..i;
		frame = _G[name];
		if ( frame ) then
			if ( not frame:IsShown() ) then
				return frame;
			end
		else
			frame = CreateFrame("Button", name, UIParent, "GlamourAlertFrameTemplate");
			if ( not previousFrame ) then
				frame:SetPoint("CENTER", UIErrorsFrame, "BOTTOM", 0, 0);
			else
				frame:SetPoint("TOP", previousFrame, "BOTTOM", 0, -10);
			end
			return frame;
		end
		previousFrame = frame;
	end
	return nil;
end

function GlamourAlertFrame_OnClick (self)
--	table.foreach(self,print);
--	local id = self.id;
--	if ( not id ) then
--		return;
--	end
--	ShowUIPanel(AchievementFrame);
	return;
end

--function GlamourAlertFrame_OnHide (self)
--	AlertFrame_FixAnchors();
--end

function GlamourAchievementShield_OnLoad (self)
	self.Desaturate = AchievementShield_Desaturate;
	self.Saturate = AchievementShield_Saturate;
end

function GlamourAchievementShield_SetPoints(points, pointString, normalFont, smallFont)
	if ( strlen(points) > 3) then
		pointString:SetFontObject(normalFont);
	else
		pointString:SetFontObject(smallFont);
	end
	pointString:SetText(points);
end
